//FT8QRP

#include "si5351.h"
#include "Wire.h"

Si5351 si5351;
unsigned long  freq;

// Sorry. Comments from UN7FGO are in English only.
// ================================================
// Variable for storing the number of the current frequency.
int current_freq = 0;
// number of frequencies
int MAXFREQ = 6;
// Array of frequencies to switch.
unsigned long  freqs[6] = {7073460, 7038060, 7046960,7075460, 5356460, 3572330};
// Array of contacts to display the selected frequency
unsigned long  pins[6] = {3,4,5,9,10,11};
// Contact for connecting the frequency change button.
#define FREQ_SWITCH_PIN 12 
// ================================================

void setup(void)
{
  // ================================================
  // Operating mode of the input contact with pull-up to power supply.
  pinMode (FREQ_SWITCH_PIN,INPUT_PULLUP);
  // The default frequency is always the first in the array.  
  freq = freqs[current_freq];
  // We set the mode of operation of contacts to display the selected frequency
  // and turn off all LEDs
  for (int i=0; i<MAXFREQ; i++) {
    pinMode (pins[i],OUTPUT);  
    digitalWrite(pins[i],LOW);
  }
  // Turn on the LED for the first frequency memory cell
  digitalWrite(pins[0],HIGH);
  // ================================================
  
  word cal_factor = 0;
  si5351.init(SI5351_CRYSTAL_LOAD_8PF, 0, 0); 
  si5351.set_correction(cal_factor, SI5351_PLL_INPUT_XO);
 
  si5351.set_pll(SI5351_PLL_FIXED, SI5351_PLLA);
  si5351.set_freq(freq*100ULL, SI5351_CLK1);
  si5351.output_enable(SI5351_CLK1, 1);
 
  si5351.set_freq(freq*100ULL, SI5351_CLK0);
  si5351.drive_strength(SI5351_CLK0, SI5351_DRIVE_8MA);
  si5351.output_enable(SI5351_CLK0, 0);
  TCCR1A = 0x00;
  TCCR1B = 0x01; // Timer1 Timer 16 MHz
  TCCR1B = 0x81; // Timer1 Input Capture Noise Canceler
  ACSR |= (1<<ACIC);  // Analog Comparator Capture Input
  pinMode(7, INPUT); //PD7 = AN1 = HiZ, PD6 = AN0 = 0
  pinMode(13, OUTPUT);
}


void loop(void)
{
  // Added UN7FGO.
  // ================================================
  // We process the press of the frequency change button.
  if (digitalRead(FREQ_SWITCH_PIN) == 0) {
    // If the button is pressed, then go to the next frequency.
    // Increase the frequency number by 1.
    current_freq++;
    // If we reach the last frequency in the list, go to the beginning of the list.
    if (current_freq == MAXFREQ) {
      current_freq = 0;
    }
    // We read a new frequency from the array.
    freq = freqs[current_freq];
    // We set the frequency of the receiver local oscillator.
    si5351.set_freq(freq*100ULL, SI5351_CLK1);
    // Turn off all LEDs
    for (int i=0; i<MAXFREQ; i++) {
      digitalWrite(pins[i],LOW);
    }
    // Turn on the LED for the selected frequency
    digitalWrite(pins[current_freq],HIGH);
    // We are waiting for half a second to avoid reprocessing of pressing the frequency change button.
    delay(500);
  }  
  // ================================================
  // End of addition from UN7FGO.


 // Modulationsfrequenz messen über Analog Comparator Pin7 = AN1

 unsigned int d1,d2;
 int FSK = 10;
 int FSKtx = 0;
 while (FSK>0){
  TCNT1 = 0;
  while (ACSR &(1<<ACO)){
    if (TCNT1>65000) {break;
  }
  }  while ((ACSR &(1<<ACO))==0){
    if (TCNT1>65000) {break;}
  }
  TCNT1 = 0;
  while (ACSR &(1<<ACO)){
    if (TCNT1>65000) {break;}
  }
  d1 = ICR1;  
  while ((ACSR &(1<<ACO))==0){
    if (TCNT1>65000) {break;}
  } 
  while (ACSR &(1<<ACO)){
    if (TCNT1>65000) {break;}
  }
  d2 = ICR1;
  if (TCNT1 < 65000){
  unsigned long codefreq = 1600000000/(d2-d1);
    if (codefreq < 350000){
      if (FSKtx == 0){
          digitalWrite(13,1);
          si5351.output_enable(SI5351_CLK1, 0);   //RX off
          si5351.output_enable(SI5351_CLK0, 1);   // TX on
      }
      si5351.set_freq((freq * 100 + codefreq), SI5351_CLK0);  
      FSKtx = 1;
    }
  }
  else{
    FSK--;
  }
 }
  digitalWrite(13,0);
  si5351.output_enable(SI5351_CLK0, 0);   //TX off
  si5351.output_enable(SI5351_CLK1, 1);   //RX on
  FSKtx = 0;
}
